package publish

import (
	"github.com/goccy/go-json"
	"github.com/streadway/amqp"
	"log"
)

func Send(channel *amqp.Channel, exchange, route string, mandatory, immediate bool, data interface{}) error {
	bytes, err := json.Marshal(data)
	if err != nil {
		return err
	}

	if err = channel.Publish(
		exchange, // exchange
		route,    // routing key
		false,    // mandatory
		false,    // immediate
		amqp.Publishing{
			Headers:         amqp.Table{},
			ContentType:     "text/plain",
			ContentEncoding: "",
			Body:            bytes,
			//Expiration:      "60000", // 消息过期时间
		},
	); err != nil {
		log.Println("Failed to publish a message:", err.Error())
		return err
	}
	return nil
}
